using CallCenterApi.DB;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CallCenterApi.DAL
{
    /// <summary>
	/// 数据访问类:T_Call_RecordSet
	/// </summary>
	public partial class T_Call_RecordSet
    {
        public T_Call_RecordSet()
        { }
        #region  BasicMethod

        /// <summary>
		/// 增加一条数据
		/// </summary>
		public int Add(CallCenterApi.Model.T_Call_RecordSet model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Call_RecordSet(");
            strSql.Append("F_Telphone,F_Type,F_Des,F_CreateOn,F_CreateBy)");
            strSql.Append(" values (");
            strSql.Append("@F_Telphone,@F_Type,@F_Des,@F_CreateOn,@F_CreateBy)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Telphone", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_Type", SqlDbType.Int,4),
                    new SqlParameter("@F_Des", SqlDbType.NText),
                    new SqlParameter("@F_CreateOn", SqlDbType.DateTime),
                    new SqlParameter("@F_CreateBy", SqlDbType.Int,4)};
            parameters[0].Value = model.F_Telphone;
            parameters[1].Value = model.F_Type;
            parameters[2].Value = model.F_Des;
            parameters[3].Value = model.F_CreateOn;
            parameters[4].Value = model.F_CreateBy;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(CallCenterApi.Model.T_Call_RecordSet model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Call_RecordSet set ");
            strSql.Append("F_Telphone=@F_Telphone,");
            strSql.Append("F_Type=@F_Type,");
            strSql.Append("F_Des=@F_Des,");
            strSql.Append("F_CreateOn=@F_CreateOn,");
            strSql.Append("F_CreateBy=@F_CreateBy");
            strSql.Append(" where F_Rid=@F_Rid");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Telphone", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_Type", SqlDbType.Int,4),
                    new SqlParameter("@F_Des", SqlDbType.NText),
                    new SqlParameter("@F_CreateOn", SqlDbType.DateTime),
                    new SqlParameter("@F_CreateBy", SqlDbType.Int,4),
                    new SqlParameter("@F_Rid", SqlDbType.Int,4)};
            parameters[0].Value = model.F_Telphone;
            parameters[1].Value = model.F_Type;
            parameters[2].Value = model.F_Des;
            parameters[3].Value = model.F_CreateOn;
            parameters[4].Value = model.F_CreateBy;
            parameters[5].Value = model.F_Rid;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_Rid)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Call_RecordSet ");
            strSql.Append(" where F_Rid=@F_Rid");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Rid", SqlDbType.Int,4)
            };
            parameters[0].Value = F_Rid;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_Ridlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Call_RecordSet ");
            strSql.Append(" where F_Rid in (" + F_Ridlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Call_RecordSet GetModel(int F_Rid)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_Rid,F_Telphone,F_Type,F_Des,F_CreateOn,F_CreateBy from T_Call_RecordSet ");
            strSql.Append(" where F_Rid=@F_Rid");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Rid", SqlDbType.Int,4)
            };
            parameters[0].Value = F_Rid;

            CallCenterApi.Model.T_Call_RecordSet model = new CallCenterApi.Model.T_Call_RecordSet();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Call_RecordSet DataRowToModel(DataRow row)
        {
            CallCenterApi.Model.T_Call_RecordSet model = new CallCenterApi.Model.T_Call_RecordSet();
            if (row != null)
            {
                if (row["F_Rid"] != null && row["F_Rid"].ToString() != "")
                {
                    model.F_Rid = int.Parse(row["F_Rid"].ToString());
                }
                if (row["F_Telphone"] != null)
                {
                    model.F_Telphone = row["F_Telphone"].ToString();
                }
                if (row["F_Type"] != null && row["F_Type"].ToString() != "")
                {
                    model.F_Type = int.Parse(row["F_Type"].ToString());
                }
                if (row["F_Des"] != null)
                {
                    model.F_Des = row["F_Des"].ToString();
                }
                if (row["F_CreateOn"] != null && row["F_CreateOn"].ToString() != "")
                {
                    model.F_CreateOn = DateTime.Parse(row["F_CreateOn"].ToString());
                }
                if (row["F_CreateBy"] != null && row["F_CreateBy"].ToString() != "")
                {
                    model.F_CreateBy = int.Parse(row["F_CreateBy"].ToString());
                }
            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select F_Rid,F_Telphone,F_Type,F_Des,F_CreateOn,F_CreateBy ");
            strSql.Append(" FROM T_Call_RecordSet ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" F_Rid,F_Telphone,F_Type,F_Des,F_CreateOn,F_CreateBy ");
            strSql.Append(" FROM T_Call_RecordSet ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Call_RecordSet ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_Rid desc");
            }
            strSql.Append(")AS Row, T.*  from T_Call_RecordSet T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }
        #endregion  BasicMethod
        #region  ExtensionMethod

        #endregion  ExtensionMethod
    }
}
